package transportgrpc

import (
	"git.perx.ru/perxis/perxis-go/pkg/delivery"
	"git.perx.ru/perxis/perxis-go/pkg/delivery/transport"
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	pb "git.perx.ru/perxis/perxis-go/proto/delivery"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc delivery.Delivery, opts ...grpckit.ServerOption) pb.DeliveryServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		AggregateEndpoint:        grpcerr.ServerMiddleware(eps.AggregateEndpoint),
		FindItemsEndpoint:        grpcerr.ServerMiddleware(eps.FindItemsEndpoint),
		GetCollectionEndpoint:    grpcerr.ServerMiddleware(eps.GetCollectionEndpoint),
		GetEnvironmentEndpoint:   grpcerr.ServerMiddleware(eps.GetEnvironmentEndpoint),
		GetItemEndpoint:          grpcerr.ServerMiddleware(eps.GetItemEndpoint),
		ListCollectionsEndpoint:  grpcerr.ServerMiddleware(eps.ListCollectionsEndpoint),
		ListEnvironmentsEndpoint: grpcerr.ServerMiddleware(eps.ListEnvironmentsEndpoint),
		ListLocalesEndpoint:      grpcerr.ServerMiddleware(eps.ListLocalesEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
